/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef jit_AtomicOperationsGenerated_h
#define jit_AtomicOperationsGenerated_h

/* This file is generated by jit/GenerateAtomicOperations.py. Do not edit! */

#include "mozilla/Attributes.h"

namespace js {
namespace jit {

#define JS_HAVE_GENERATED_ATOMIC_OPS 1
            MOZ_NEVER_INLINE inline void AtomicFenceSeqCst() {
                asm volatile ("mfence\n\t" ::: "memory");
            }
            MOZ_NEVER_INLINE inline uint8_t AtomicLoad8SeqCst(const uint8_t* arg) {
                uint8_t res;
                asm volatile ("mfence\n\t"
"movb (%[arg]), %[res]\n\t"
"mfence\n\t"

                    : [res] "=r" (res)
                    : [arg] "r" (arg)
                    : "memory");
                return res;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicLoad16SeqCst(const uint16_t* arg) {
                uint16_t res;
                asm volatile ("mfence\n\t"
"movw (%[arg]), %[res]\n\t"
"mfence\n\t"

                    : [res] "=r" (res)
                    : [arg] "r" (arg)
                    : "memory");
                return res;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicLoad32SeqCst(const uint32_t* arg) {
                uint32_t res;
                asm volatile ("mfence\n\t"
"movl (%[arg]), %[res]\n\t"
"mfence\n\t"

                    : [res] "=r" (res)
                    : [arg] "r" (arg)
                    : "memory");
                return res;
            }
            MOZ_NEVER_INLINE inline uint8_t AtomicLoad8Unsynchronized(const uint8_t* arg) {
                uint8_t res;
                asm volatile ("movb (%[arg]), %[res]\n\t"

                    : [res] "=r" (res)
                    : [arg] "r" (arg)
                    : "memory");
                return res;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicLoad16Unsynchronized(const uint16_t* arg) {
                uint16_t res;
                asm volatile ("movw (%[arg]), %[res]\n\t"

                    : [res] "=r" (res)
                    : [arg] "r" (arg)
                    : "memory");
                return res;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicLoad32Unsynchronized(const uint32_t* arg) {
                uint32_t res;
                asm volatile ("movl (%[arg]), %[res]\n\t"

                    : [res] "=r" (res)
                    : [arg] "r" (arg)
                    : "memory");
                return res;
            }
            MOZ_NEVER_INLINE inline void AtomicStore8SeqCst(uint8_t* addr, uint8_t val) {
                asm volatile ("mfence\n\t"
"movb %[val], (%[addr])\n\t"
"mfence\n\t"

                    :
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory");
            }
            MOZ_NEVER_INLINE inline void AtomicStore16SeqCst(uint16_t* addr, uint16_t val) {
                asm volatile ("mfence\n\t"
"movw %[val], (%[addr])\n\t"
"mfence\n\t"

                    :
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory");
            }
            MOZ_NEVER_INLINE inline void AtomicStore32SeqCst(uint32_t* addr, uint32_t val) {
                asm volatile ("mfence\n\t"
"movl %[val], (%[addr])\n\t"
"mfence\n\t"

                    :
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory");
            }
            MOZ_NEVER_INLINE inline void AtomicStore8Unsynchronized(uint8_t* addr, uint8_t val) {
                asm volatile ("movb %[val], (%[addr])\n\t"

                    :
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory");
            }
            MOZ_NEVER_INLINE inline void AtomicStore16Unsynchronized(uint16_t* addr, uint16_t val) {
                asm volatile ("movw %[val], (%[addr])\n\t"

                    :
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory");
            }
            MOZ_NEVER_INLINE inline void AtomicStore32Unsynchronized(uint32_t* addr, uint32_t val) {
                asm volatile ("movl %[val], (%[addr])\n\t"

                    :
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory");
            }
            MOZ_NEVER_INLINE inline uint8_t AtomicExchange8SeqCst(uint8_t* addr, uint8_t val) {
                asm volatile ("xchgb %[val], (%[addr])\n\t"

                    : [val] "+r" (val)
                    : [addr] "r" (addr)
                    : "memory");
                return val;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicExchange16SeqCst(uint16_t* addr, uint16_t val) {
                asm volatile ("xchgw %[val], (%[addr])\n\t"

                    : [val] "+r" (val)
                    : [addr] "r" (addr)
                    : "memory");
                return val;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicExchange32SeqCst(uint32_t* addr, uint32_t val) {
                asm volatile ("xchgl %[val], (%[addr])\n\t"

                    : [val] "+r" (val)
                    : [addr] "r" (addr)
                    : "memory");
                return val;
            }
            MOZ_NEVER_INLINE inline uint8_t AtomicCmpXchg8SeqCst(uint8_t* addr,
                                             uint8_t oldval,
                                             uint8_t newval) {
                asm volatile ("lock; cmpxchgb %[newval], (%[addr])\n\t"

                    : [oldval] "+a" (oldval)
                    : [addr] "r" (addr), [newval] "r" (newval)
                    : "memory", "cc");
                return oldval;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicCmpXchg16SeqCst(uint16_t* addr,
                                             uint16_t oldval,
                                             uint16_t newval) {
                asm volatile ("lock; cmpxchgw %[newval], (%[addr])\n\t"

                    : [oldval] "+a" (oldval)
                    : [addr] "r" (addr), [newval] "r" (newval)
                    : "memory", "cc");
                return oldval;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicCmpXchg32SeqCst(uint32_t* addr,
                                             uint32_t oldval,
                                             uint32_t newval) {
                asm volatile ("lock; cmpxchgl %[newval], (%[addr])\n\t"

                    : [oldval] "+a" (oldval)
                    : [addr] "r" (addr), [newval] "r" (newval)
                    : "memory", "cc");
                return oldval;
            }
            MOZ_NEVER_INLINE inline uint64_t AtomicCmpXchg64SeqCst(uint64_t* addr,
                                             uint64_t oldval,
                                             uint64_t newval) {
                asm volatile ("lock; cmpxchg8b (%[addr])\n\t"
                : "+A" (oldval)
                : [addr] "r" (addr),
                  "b" (uint32_t(newval & 0xffff'ffff)),
                  "c" (uint32_t(newval >> 32))
                : "memory", "cc");
                return oldval;
            }
                MOZ_NEVER_INLINE inline uint8_t AtomicAdd8SeqCst(uint8_t* addr, uint8_t val) {
                    asm volatile ("lock; xaddb %[val], (%[addr])\n\t"

                        : [val] "+&r" (val)
                        : [addr] "r" (addr)
                        : "memory", "cc");
                    return val;
                }
                MOZ_NEVER_INLINE inline uint16_t AtomicAdd16SeqCst(uint16_t* addr, uint16_t val) {
                    asm volatile ("lock; xaddw %[val], (%[addr])\n\t"

                        : [val] "+&r" (val)
                        : [addr] "r" (addr)
                        : "memory", "cc");
                    return val;
                }
                MOZ_NEVER_INLINE inline uint32_t AtomicAdd32SeqCst(uint32_t* addr, uint32_t val) {
                    asm volatile ("lock; xaddl %[val], (%[addr])\n\t"

                        : [val] "+&r" (val)
                        : [addr] "r" (addr)
                        : "memory", "cc");
                    return val;
                }
            MOZ_NEVER_INLINE inline uint8_t AtomicAnd8SeqCst(uint8_t* addr, uint8_t val) {
                uint8_t res, scratch;
                asm volatile ("movb (%[addr]), %[res]\n\t"
"0: movb %[res], %[scratch]\n\t"
"andb %[val], %[scratch]\n\t"
"lock; cmpxchgb %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicAnd16SeqCst(uint16_t* addr, uint16_t val) {
                uint16_t res, scratch;
                asm volatile ("movw (%[addr]), %[res]\n\t"
"0: movw %[res], %[scratch]\n\t"
"andw %[val], %[scratch]\n\t"
"lock; cmpxchgw %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicAnd32SeqCst(uint32_t* addr, uint32_t val) {
                uint32_t res, scratch;
                asm volatile ("movl (%[addr]), %[res]\n\t"
"0: movl %[res], %[scratch]\n\t"
"andl %[val], %[scratch]\n\t"
"lock; cmpxchgl %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint8_t AtomicOr8SeqCst(uint8_t* addr, uint8_t val) {
                uint8_t res, scratch;
                asm volatile ("movb (%[addr]), %[res]\n\t"
"0: movb %[res], %[scratch]\n\t"
"orb %[val], %[scratch]\n\t"
"lock; cmpxchgb %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicOr16SeqCst(uint16_t* addr, uint16_t val) {
                uint16_t res, scratch;
                asm volatile ("movw (%[addr]), %[res]\n\t"
"0: movw %[res], %[scratch]\n\t"
"orw %[val], %[scratch]\n\t"
"lock; cmpxchgw %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicOr32SeqCst(uint32_t* addr, uint32_t val) {
                uint32_t res, scratch;
                asm volatile ("movl (%[addr]), %[res]\n\t"
"0: movl %[res], %[scratch]\n\t"
"orl %[val], %[scratch]\n\t"
"lock; cmpxchgl %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint8_t AtomicXor8SeqCst(uint8_t* addr, uint8_t val) {
                uint8_t res, scratch;
                asm volatile ("movb (%[addr]), %[res]\n\t"
"0: movb %[res], %[scratch]\n\t"
"xorb %[val], %[scratch]\n\t"
"lock; cmpxchgb %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint16_t AtomicXor16SeqCst(uint16_t* addr, uint16_t val) {
                uint16_t res, scratch;
                asm volatile ("movw (%[addr]), %[res]\n\t"
"0: movw %[res], %[scratch]\n\t"
"xorw %[val], %[scratch]\n\t"
"lock; cmpxchgw %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
            MOZ_NEVER_INLINE inline uint32_t AtomicXor32SeqCst(uint32_t* addr, uint32_t val) {
                uint32_t res, scratch;
                asm volatile ("movl (%[addr]), %[res]\n\t"
"0: movl %[res], %[scratch]\n\t"
"xorl %[val], %[scratch]\n\t"
"lock; cmpxchgl %[scratch], (%[addr])\n\t"
"jnz 0b\n\t"

                    : [res] "=&a" (res), [scratch] "=&r" (scratch)
                    : [addr] "r" (addr), [val] "r"(val)
                    : "memory", "cc");
                return res;
            }
        MOZ_NEVER_INLINE inline void AtomicCopyUnalignedBlockDownUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uint8_t* dst_ = reinterpret_cast<uint8_t*>(dst);
            const uint8_t* src_ = reinterpret_cast<const uint8_t*>(src);
            uint8_t scratch;
            asm volatile ("movb 0(%[src]), %[scratch]\n\t"
"movb %[scratch], 0(%[dst])\n\t"
"movb 1(%[src]), %[scratch]\n\t"
"movb %[scratch], 1(%[dst])\n\t"
"movb 2(%[src]), %[scratch]\n\t"
"movb %[scratch], 2(%[dst])\n\t"
"movb 3(%[src]), %[scratch]\n\t"
"movb %[scratch], 3(%[dst])\n\t"
"movb 4(%[src]), %[scratch]\n\t"
"movb %[scratch], 4(%[dst])\n\t"
"movb 5(%[src]), %[scratch]\n\t"
"movb %[scratch], 5(%[dst])\n\t"
"movb 6(%[src]), %[scratch]\n\t"
"movb %[scratch], 6(%[dst])\n\t"
"movb 7(%[src]), %[scratch]\n\t"
"movb %[scratch], 7(%[dst])\n\t"
"movb 8(%[src]), %[scratch]\n\t"
"movb %[scratch], 8(%[dst])\n\t"
"movb 9(%[src]), %[scratch]\n\t"
"movb %[scratch], 9(%[dst])\n\t"
"movb 10(%[src]), %[scratch]\n\t"
"movb %[scratch], 10(%[dst])\n\t"
"movb 11(%[src]), %[scratch]\n\t"
"movb %[scratch], 11(%[dst])\n\t"
"movb 12(%[src]), %[scratch]\n\t"
"movb %[scratch], 12(%[dst])\n\t"
"movb 13(%[src]), %[scratch]\n\t"
"movb %[scratch], 13(%[dst])\n\t"
"movb 14(%[src]), %[scratch]\n\t"
"movb %[scratch], 14(%[dst])\n\t"
"movb 15(%[src]), %[scratch]\n\t"
"movb %[scratch], 15(%[dst])\n\t"
"movb 16(%[src]), %[scratch]\n\t"
"movb %[scratch], 16(%[dst])\n\t"
"movb 17(%[src]), %[scratch]\n\t"
"movb %[scratch], 17(%[dst])\n\t"
"movb 18(%[src]), %[scratch]\n\t"
"movb %[scratch], 18(%[dst])\n\t"
"movb 19(%[src]), %[scratch]\n\t"
"movb %[scratch], 19(%[dst])\n\t"
"movb 20(%[src]), %[scratch]\n\t"
"movb %[scratch], 20(%[dst])\n\t"
"movb 21(%[src]), %[scratch]\n\t"
"movb %[scratch], 21(%[dst])\n\t"
"movb 22(%[src]), %[scratch]\n\t"
"movb %[scratch], 22(%[dst])\n\t"
"movb 23(%[src]), %[scratch]\n\t"
"movb %[scratch], 23(%[dst])\n\t"
"movb 24(%[src]), %[scratch]\n\t"
"movb %[scratch], 24(%[dst])\n\t"
"movb 25(%[src]), %[scratch]\n\t"
"movb %[scratch], 25(%[dst])\n\t"
"movb 26(%[src]), %[scratch]\n\t"
"movb %[scratch], 26(%[dst])\n\t"
"movb 27(%[src]), %[scratch]\n\t"
"movb %[scratch], 27(%[dst])\n\t"
"movb 28(%[src]), %[scratch]\n\t"
"movb %[scratch], 28(%[dst])\n\t"
"movb 29(%[src]), %[scratch]\n\t"
"movb %[scratch], 29(%[dst])\n\t"
"movb 30(%[src]), %[scratch]\n\t"
"movb %[scratch], 30(%[dst])\n\t"
"movb 31(%[src]), %[scratch]\n\t"
"movb %[scratch], 31(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyUnalignedBlockUpUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uint8_t* dst_ = reinterpret_cast<uint8_t*>(dst);
            const uint8_t* src_ = reinterpret_cast<const uint8_t*>(src);
            uint8_t scratch;
            asm volatile ("movb 31(%[src]), %[scratch]\n\t"
"movb %[scratch], 31(%[dst])\n\t"
"movb 30(%[src]), %[scratch]\n\t"
"movb %[scratch], 30(%[dst])\n\t"
"movb 29(%[src]), %[scratch]\n\t"
"movb %[scratch], 29(%[dst])\n\t"
"movb 28(%[src]), %[scratch]\n\t"
"movb %[scratch], 28(%[dst])\n\t"
"movb 27(%[src]), %[scratch]\n\t"
"movb %[scratch], 27(%[dst])\n\t"
"movb 26(%[src]), %[scratch]\n\t"
"movb %[scratch], 26(%[dst])\n\t"
"movb 25(%[src]), %[scratch]\n\t"
"movb %[scratch], 25(%[dst])\n\t"
"movb 24(%[src]), %[scratch]\n\t"
"movb %[scratch], 24(%[dst])\n\t"
"movb 23(%[src]), %[scratch]\n\t"
"movb %[scratch], 23(%[dst])\n\t"
"movb 22(%[src]), %[scratch]\n\t"
"movb %[scratch], 22(%[dst])\n\t"
"movb 21(%[src]), %[scratch]\n\t"
"movb %[scratch], 21(%[dst])\n\t"
"movb 20(%[src]), %[scratch]\n\t"
"movb %[scratch], 20(%[dst])\n\t"
"movb 19(%[src]), %[scratch]\n\t"
"movb %[scratch], 19(%[dst])\n\t"
"movb 18(%[src]), %[scratch]\n\t"
"movb %[scratch], 18(%[dst])\n\t"
"movb 17(%[src]), %[scratch]\n\t"
"movb %[scratch], 17(%[dst])\n\t"
"movb 16(%[src]), %[scratch]\n\t"
"movb %[scratch], 16(%[dst])\n\t"
"movb 15(%[src]), %[scratch]\n\t"
"movb %[scratch], 15(%[dst])\n\t"
"movb 14(%[src]), %[scratch]\n\t"
"movb %[scratch], 14(%[dst])\n\t"
"movb 13(%[src]), %[scratch]\n\t"
"movb %[scratch], 13(%[dst])\n\t"
"movb 12(%[src]), %[scratch]\n\t"
"movb %[scratch], 12(%[dst])\n\t"
"movb 11(%[src]), %[scratch]\n\t"
"movb %[scratch], 11(%[dst])\n\t"
"movb 10(%[src]), %[scratch]\n\t"
"movb %[scratch], 10(%[dst])\n\t"
"movb 9(%[src]), %[scratch]\n\t"
"movb %[scratch], 9(%[dst])\n\t"
"movb 8(%[src]), %[scratch]\n\t"
"movb %[scratch], 8(%[dst])\n\t"
"movb 7(%[src]), %[scratch]\n\t"
"movb %[scratch], 7(%[dst])\n\t"
"movb 6(%[src]), %[scratch]\n\t"
"movb %[scratch], 6(%[dst])\n\t"
"movb 5(%[src]), %[scratch]\n\t"
"movb %[scratch], 5(%[dst])\n\t"
"movb 4(%[src]), %[scratch]\n\t"
"movb %[scratch], 4(%[dst])\n\t"
"movb 3(%[src]), %[scratch]\n\t"
"movb %[scratch], 3(%[dst])\n\t"
"movb 2(%[src]), %[scratch]\n\t"
"movb %[scratch], 2(%[dst])\n\t"
"movb 1(%[src]), %[scratch]\n\t"
"movb %[scratch], 1(%[dst])\n\t"
"movb 0(%[src]), %[scratch]\n\t"
"movb %[scratch], 0(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyUnalignedWordDownUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uint8_t* dst_ = reinterpret_cast<uint8_t*>(dst);
            const uint8_t* src_ = reinterpret_cast<const uint8_t*>(src);
            uint8_t scratch;
            asm volatile ("movb 0(%[src]), %[scratch]\n\t"
"movb %[scratch], 0(%[dst])\n\t"
"movb 1(%[src]), %[scratch]\n\t"
"movb %[scratch], 1(%[dst])\n\t"
"movb 2(%[src]), %[scratch]\n\t"
"movb %[scratch], 2(%[dst])\n\t"
"movb 3(%[src]), %[scratch]\n\t"
"movb %[scratch], 3(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyUnalignedWordUpUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uint8_t* dst_ = reinterpret_cast<uint8_t*>(dst);
            const uint8_t* src_ = reinterpret_cast<const uint8_t*>(src);
            uint8_t scratch;
            asm volatile ("movb 3(%[src]), %[scratch]\n\t"
"movb %[scratch], 3(%[dst])\n\t"
"movb 2(%[src]), %[scratch]\n\t"
"movb %[scratch], 2(%[dst])\n\t"
"movb 1(%[src]), %[scratch]\n\t"
"movb %[scratch], 1(%[dst])\n\t"
"movb 0(%[src]), %[scratch]\n\t"
"movb %[scratch], 0(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyBlockDownUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uintptr_t* dst_ = reinterpret_cast<uintptr_t*>(dst);
            const uintptr_t* src_ = reinterpret_cast<const uintptr_t*>(src);
            uintptr_t scratch;
            asm volatile ("movl 0(%[src]), %[scratch]\n\t"
"movl %[scratch], 0(%[dst])\n\t"
"movl 4(%[src]), %[scratch]\n\t"
"movl %[scratch], 4(%[dst])\n\t"
"movl 8(%[src]), %[scratch]\n\t"
"movl %[scratch], 8(%[dst])\n\t"
"movl 12(%[src]), %[scratch]\n\t"
"movl %[scratch], 12(%[dst])\n\t"
"movl 16(%[src]), %[scratch]\n\t"
"movl %[scratch], 16(%[dst])\n\t"
"movl 20(%[src]), %[scratch]\n\t"
"movl %[scratch], 20(%[dst])\n\t"
"movl 24(%[src]), %[scratch]\n\t"
"movl %[scratch], 24(%[dst])\n\t"
"movl 28(%[src]), %[scratch]\n\t"
"movl %[scratch], 28(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyBlockUpUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uintptr_t* dst_ = reinterpret_cast<uintptr_t*>(dst);
            const uintptr_t* src_ = reinterpret_cast<const uintptr_t*>(src);
            uintptr_t scratch;
            asm volatile ("movl 28(%[src]), %[scratch]\n\t"
"movl %[scratch], 28(%[dst])\n\t"
"movl 24(%[src]), %[scratch]\n\t"
"movl %[scratch], 24(%[dst])\n\t"
"movl 20(%[src]), %[scratch]\n\t"
"movl %[scratch], 20(%[dst])\n\t"
"movl 16(%[src]), %[scratch]\n\t"
"movl %[scratch], 16(%[dst])\n\t"
"movl 12(%[src]), %[scratch]\n\t"
"movl %[scratch], 12(%[dst])\n\t"
"movl 8(%[src]), %[scratch]\n\t"
"movl %[scratch], 8(%[dst])\n\t"
"movl 4(%[src]), %[scratch]\n\t"
"movl %[scratch], 4(%[dst])\n\t"
"movl 0(%[src]), %[scratch]\n\t"
"movl %[scratch], 0(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyWordUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uintptr_t* dst_ = reinterpret_cast<uintptr_t*>(dst);
            const uintptr_t* src_ = reinterpret_cast<const uintptr_t*>(src);
            uintptr_t scratch;
            asm volatile ("movl 0(%[src]), %[scratch]\n\t"
"movl %[scratch], 0(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
        MOZ_NEVER_INLINE inline void AtomicCopyByteUnsynchronized(uint8_t* dst, const uint8_t* src) {
            uint8_t* dst_ = reinterpret_cast<uint8_t*>(dst);
            const uint8_t* src_ = reinterpret_cast<const uint8_t*>(src);
            uint8_t scratch;
            asm volatile ("movb 0(%[src]), %[scratch]\n\t"
"movb %[scratch], 0(%[dst])\n\t"

                : [scratch] "=&r" (scratch)
                : [dst] "r" (dst_), [src] "r"(src_)
                : "memory");
        }
constexpr size_t JS_GENERATED_ATOMICS_BLOCKSIZE = 32;
constexpr size_t JS_GENERATED_ATOMICS_WORDSIZE = 4;


} // namespace jit
} // namespace js

#endif // jit_AtomicOperationsGenerated_h
